import { BeforeUpdateHookSync, CacheEntanglement, CacheEntanglementConstructorOption, CacheGetter, CacheGetterParams, DependencyCacheData, DependencyMap } from './CacheEntanglement';
import { CacheData } from './CacheData';
export declare class CacheEntanglementSync<D extends DependencyMap, G extends CacheGetter<DependencyCacheData<D>>> extends CacheEntanglement<D, G> {
    protected readonly beforeUpdateHook: BeforeUpdateHookSync<D, G>;
    constructor(creation: G, option?: CacheEntanglementConstructorOption<D, G>);
    protected recache(key: string): CacheData<Awaited<ReturnType<G>>> | undefined;
    protected resolve(key: string, ...parameter: CacheGetterParams<G>): CacheData<Awaited<ReturnType<G>>>;
    get(key: string): CacheData<Awaited<ReturnType<G>>>;
    cache(key: string, ...parameter: CacheGetterParams<G>): CacheData<Awaited<ReturnType<G>>>;
    update(key: string, ...parameter: CacheGetterParams<G>): CacheData<Awaited<ReturnType<G>>>;
}
