interface InvertedWeakMapConstructorArguments {
    lifespan: number;
}
export declare class InvertedWeakMap<K extends string | number | symbol, V extends WeakKey> {
    private readonly _map;
    private readonly _keepAlive;
    private readonly _timeouts;
    private readonly _registry;
    private readonly _lifespan;
    constructor(option: InvertedWeakMapConstructorArguments);
    clear(): void;
    delete(key: K): boolean;
    get(key: K): V | undefined;
    has(key: K): boolean;
    set(key: K, value: V): this;
    extendExpire(key: K): void;
    private _startExpire;
    private _stopExpire;
    get size(): number;
    keys(): IterableIterator<K>;
}
export {};
